# Deploy playbook

## Purpose

The goal of this playbook is to execute ONAP community tests. There are 2 ways
to execute tests either from an external docker or as a k8s job. This playbook
is the umbrella playbook that abstract the type of test for the end users.
In fact the end user has just to know the name of the test, this playbook
will call the acurate role (run_xtesting_docker or run_xtesting_k8s_job)
according to the test name.

The list of possible community tests:

- onap-k8s
- onap-helm
- nodeport-certs
- internal_certs
- core
- small
- medium
- full
- healthdist
- postinstall
- dcaemod
- hv-ves
- ves-collector
- 5gbulkpm
- pnf-registrate
- cmpv2
- basic_onboard
- basic_vm
- basic_vm_macro
- basic_network
- basic_cds
- basic_clamp
- root_pods
- unlimitted_pods
- jdpw_ports
- nonssl_endpoints
- versions

See <https://docs.onap.org/projects/onap-integration/en/latest/integration-tests.html#automatic-tests>
for details.

You can run 1 single test or 1 category of tests.
The possible categories are:

- all: run all tests
- infra: run all infrastructure related tests
- healthcheck: run all healthcheck tests
- smoke: run all smoke tests
- security: run all security tests
- 3rd_party

Please note that the third party category is dedicated to non community tests.
You may include any xtesting tests and create an override file to provide the
needed information to the collection.

## Inventory

The inventory must provide a group `vm-test` with **at least one** server inside.

This server must provide access to ONAP cluster credentials via a kube
config file associated in default location
(`{{ ansible_user_dir }}/.kube/config`) for the chosen user on the server.
It must also include the openstack credentials to perform VM operations through
ONAP test via a clouds.yaml file in default location
(`{{ ansible_user_dir }}/.config/openstack/clouds.yaml`) for the chosen user on
the server.

```shell
.
├── inventory
   └── inventory
```

## Mandatory parameters

None

## Optional parameters

- add it in `inventory_dir/../vars/tests.yml` or in
  `inventory_dir/../vars/idf.yml` (see optional parameters to see how to change)
- here an example of the file content in an ORONAP context :

  ```yaml
    onap_testing_nb_max_retry: 1
    onap_testing_run_timeout: 60
  ```

On top of all variables from roles, the playbook adds the following variables:

<!-- markdownlint-disable line-length -->
| Variable                    | Purpose                                          | Default value            |
|-----------------------------|--------------------------------------------------|--------------------------|
| `cluster_file`              | cluster file to load (generated by OOM)          | `cluster.yml`. Optional  |
| `property_file`             | property file to load (generic override values)  | `idf.yml`. Optional      |
| `test_file`                 | test file to load (specific values for this run) | `tests.yml`. Optional    |
| `base_dir`                  | override file to load folder                     | `{{ inventory_dir }}/..` |
| `onap_testing_test_name`    | name of the test                                 | Not set                  |
| `onap_testing_nb_max_retry` | number of max retry                              | 0                        |
| `onap_testing_run_timeout`  | test ansible timeout duration                    | 60 (minutes)             |
| `onap_testing_category`     | category of tests to be run                      | Not set                  |
<!-- markdownlint-disable line-length -->

onap_testing_test_name and onap_testing_category are exclusive.
onap_testing_test_name has the priority on onap_testing_category.
At least one of the 2 values must be set on playbook call.

## Examples

Inventory:

```ini
[test-vm]
honolulu.onap.eu ansible_user=toto
```

Launch:

```shell
ansible-playbook -i inventory/inventory playbooks/run_onap_test.yml \
  --extra-vars "onap_testing_test_name=core"

ansible-playbook -i inventory/inventory playbooks/run_onap_test.yml \
  --extra-vars "onap_testing_test_name=basic_onboarding"

ansible-playbook -i inventory/inventory playbooks/run_onap_test.yml \
  --extra-vars
    "onap_testing_test_name=basic_vm onap_testing_run_timeout=15"

ansible-playbook -i inventory/inventory playbooks/run_onap_test.yml \
  --extra-vars
    "onap_testing_test_name=unlimitted_pods
     onap_testing_run_timeout=5
     onap_testing_nb_max_retry=2"

ansible-playbook -i inventory/inventory playbooks/run_onap_test.yml \
   --extra-vars
     "onap_testing_test_category=all
      onap_testing_run_timeout=5"

ansible-playbook -i inventory/inventory playbooks/run_onap_test.yml \
   --extra-vars
     "onap_testing_test_category=my_custom_test
      onap_testing_run_timeout=1"
```

For customized test, you must create an override file that declares
properly the my_custom_test test. In the example here after we use
the kubernetes job launcher to run this test.

```yaml
---
deployment_name: my-deployment-lab

onap_testing_k8s_job_tests:
  - my_custom_test

onap_testing_category_tests:
  3rd_party:
    - my_custom_test

onap_testing_k8s_job_category:
  my_custom_test: 3rd_party

onap_testing_test_name: my_custom_test
onap_testing_docker_images:
    3rd_party: my_docker_registry/my_custom_xtesting_docker
onap_testing_docker_version: my_custom_xtesting_version
onap_testing_k8s_job_args:
  - --test
  - all
  - --push
  - --report

onap_testing_k8s_job_deployment_env:
    - name: ONAP_NAMESPACE
      value: "{{ onap_namespace }}"
    - name: CUSTOM_ENV_VAR1
      value: value1
    - name: CUSTOM_ENV_VAR2
      value: value2
```
